//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%46D85065025F.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%46D85065025F.cm

//## begin module%46D85065025F.cp preserve=no
//## end module%46D85065025F.cp

//## Module: AsciiChain%46D85065025F; Package body
//## Subsystem: XSFit::MCMC%41E6AA18032C
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSFit/MCMC/AsciiChain.cxx

//## begin module%46D85065025F.additionalIncludes preserve=no
//## end module%46D85065025F.additionalIncludes

//## begin module%46D85065025F.includes preserve=yes
#include <XSContainer.h>
#include <XSstreams.h>
#include <XSFit/Fit/Fit.h>
#include <XSFit/Fit/StatMethod.h>
#include <XSModel/Model/Model.h>
#include <XSUtil/Parse/XSparse.h>
#include <XSUtil/Utils/XSstream.h>
#include <sstream>
//## end module%46D85065025F.includes

// Chain
#include <XSFit/MCMC/Chain.h>
// AsciiChain
#include <XSFit/MCMC/AsciiChain.h>


//## begin module%46D85065025F.declarations preserve=no
//## end module%46D85065025F.declarations

//## begin module%46D85065025F.additionalDeclarations preserve=yes
//## end module%46D85065025F.additionalDeclarations


// Class AsciiChain 

//## begin AsciiChain::LENGTHFIELDWIDTH%46DD91C102CE.attr preserve=no  private: static const size_t {U} 14
const size_t AsciiChain::s_LENGTHFIELDWIDTH = 14;
//## end AsciiChain::LENGTHFIELDWIDTH%46DD91C102CE.attr

//## begin AsciiChain::TEMPERFIELDWIDTH%46DD920401EB.attr preserve=no  private: static const int {U} 200
const int AsciiChain::s_TEMPERFIELDWIDTH = 200;
//## end AsciiChain::TEMPERFIELDWIDTH%46DD920401EB.attr

//## begin AsciiChain::FORMATNAME%46DDBAA30219.attr preserve=no  public: static const string {U} string("ascii")
const string AsciiChain::s_FORMATNAME = string("ascii");
//## end AsciiChain::FORMATNAME%46DDBAA30219.attr

AsciiChain::AsciiChain (string fileName)
  //## begin AsciiChain::AsciiChain%46DDB8450345.hasinit preserve=no
  //## end AsciiChain::AsciiChain%46DDB8450345.hasinit
  //## begin AsciiChain::AsciiChain%46DDB8450345.initialization preserve=yes
  : m_file(),
    m_lengthInfoPos(0),
    m_pointsStartPos(0),
    m_temperInfoPos(-1),
    m_chain(0) // non-owning
  //## end AsciiChain::AsciiChain%46DDB8450345.initialization
{
  //## begin AsciiChain::AsciiChain%46DDB8450345.body preserve=yes
   if (fileName.length())
   {
      // We are attempting to load an already existing chain file,
      // but we don't yet know if its format is Ascii.
      // This may throw.
      testFile(fileName);      
   }
  //## end AsciiChain::AsciiChain%46DDB8450345.body
}


AsciiChain::~AsciiChain()
{
  //## begin AsciiChain::~AsciiChain%46DD7BF103B0_dest.body preserve=yes
  //## end AsciiChain::~AsciiChain%46DD7BF103B0_dest.body
}



//## Other Operations (implementation)
void AsciiChain::doOpenForReadPoints () const
{
  //## begin AsciiChain::doOpenForReadPoints%46DD86EE022E.body preserve=yes
  using namespace std;
  m_file.open(m_chain->getFileName().c_str(), ios_base::in);
  if (!m_file)
  {
     string msg("Unable to open chain file ");
     msg += m_chain->getFileName().c_str();
     throw ChainIOError(msg);
  }
  m_file.seekg(m_pointsStartPos);
  //## end AsciiChain::doOpenForReadPoints%46DD86EE022E.body
}

void AsciiChain::doCloseFile () const
{
  //## begin AsciiChain::doCloseFile%46DD86F5030D.body preserve=yes
  if (m_file.is_open())
     m_file.close();  
  //## end AsciiChain::doCloseFile%46DD86F5030D.body
}

void AsciiChain::doOpenForWrite ()
{
  //## begin AsciiChain::doOpenForWrite%46DF24A10281.body preserve=yes
  // Not checking results of open again.  It should already
  // have been checked.
  m_file.open(m_chain->getFileName().c_str(), 
        std::ios_base::in|std::ios_base::out);
  //## end AsciiChain::doOpenForWrite%46DF24A10281.body
}

void AsciiChain::doReadPoint (std::vector<Real>& chainVals) const
{
  //## begin AsciiChain::doReadPoint%46DD86FB0383.body preserve=yes
  // Assumes file is open and currently positioned at the 
  // proper place - the start of a line of nVal chain vals.
  const size_t nVals = m_chain->width();
  chainVals.resize(nVals, .0);
  for (size_t i=0; i<nVals; ++i)
  {
     m_file >> chainVals[i];
  }
  if (!m_file)
  {
     throw ChainIOError("Format error detected while reading chain values.");
  }
  //## end AsciiChain::doReadPoint%46DD86FB0383.body
}

void AsciiChain::doReadPointFromLine (size_t lineNum, RealArray& parVals) const
{
  //## begin AsciiChain::doReadPointFromLine%46DD870302FF.body preserve=yes
   // Assumes m_file is already open and parVals is the proper size.
   const size_t nPars = parVals.size();
   if (nPars+1 != m_chain->width())
   {
      throw RedAlert("Parameter array size mismatch with chain file.");
   }
   moveToLine(lineNum);
   // This is more complicated than just streaming directly from
   // m_file to parVals, but want to make sure all vals are 
   // indeed coming from the same line in the file.
   string valsLineStr;
   std::getline(m_file, valsLineStr);
   std::istringstream valsLine(valsLineStr);
   for (size_t i=0; i<nPars; ++i)
   {
      if (!(valsLine >> parVals[i]))
      {
         std::ostringstream errMsg;
         errMsg <<"Unable to read par values at values line " << lineNum
            <<".\n   Chain file format is wrong.";
         throw ChainIOError(errMsg.str());
      }
   }
  //## end AsciiChain::doReadPointFromLine%46DD870302FF.body
}

const string& AsciiChain::getFormatName () const
{
  //## begin AsciiChain::getFormatName%46DDBF89013B.body preserve=yes
   return s_FORMATNAME;
  //## end AsciiChain::getFormatName%46DDBF89013B.body
}

void AsciiChain::readFileInfo ()
{
  //## begin AsciiChain::readFileInfo%46DD90BA0181.body preserve=yes
  m_file.open(m_chain->getFileName().c_str(), std::ios_base::in);
  if (!m_file)
  {
     string msg("Unable to open chain file ");
     msg += m_chain->getFileName();
     throw ChainIOError(msg);
  }
  
  try
  {
     string paramLine;
     // Swallow message in 1st 2 lines:
     std::getline(m_file, paramLine);
     std::getline(m_file, paramLine);
     string testStr;
     m_file >> testStr;
     if (!testStr.length() || testStr[0] != '!') throw YellowAlert();
     if (testStr.substr(1) != string(ChainIO::LENGTHLABEL()+":")) 
                throw YellowAlert();
     size_t chainLength=0;
     m_lengthInfoPos = m_file.tellg();
     m_file >> chainLength >> testStr;
     if (!chainLength)
        throw YellowAlert("Chain length must be > 0\n");
     m_chain->length(chainLength);
     
     if (testStr != string(ChainIO::WIDTHLABEL()+":")) 
        throw YellowAlert();
     size_t chainWidth=0;
     m_file >> chainWidth;
     if (!chainWidth)
        throw YellowAlert("Chain width must be > 0\n");
     m_chain->width(chainWidth);
     
     // Need to find only whitespace then '/n', else throw.
     char c = ' ';
     while (isspace(c))
     {
        m_file.get(c);
        if (c == '\n') break;
     }
     if (c != '\n') throw YellowAlert();

     // 2nd line, get tempering info.  If it's not there
     // (older files), this should return the next line
     // containing parameter info.
     paramLine = readTemperInfo();      
     // 3nd line, get param info (if it hasn't been retrieved above).
     std::vector<Chain::ParamID> paramIDs;
     if (!paramLine.length())
        std::getline(m_file, paramLine);
     m_pointsStartPos = m_file.tellg();
     if (!paramLine.length() || paramLine[0] != '!') throw YellowAlert();
     const string WS(" \n\t");
     string::size_type start = 1;
     while (start != string::npos)
     {
        string::size_type end = paramLine.find_first_of(WS, start);
        string::size_type n = (end == string::npos) ? string::npos : end-start;
        string tmp(paramLine.substr(start, n));
        string modName;
        size_t index=0;
        Chain::ParamID inPar;
        if (!XSparse::stringIntPair(tmp, modName, index))
        {
	    //could be the fit statistic...
	    if (!index)
	    {
		//Note: Don't assume anything about the format of the fit
		//statistic. Could contain spaces and other chars. The only
		//character that it should not contain is a colon - check.

		//assume EVERYTHING from the start of the line until the end
		//is the name of the fit statistic
		if(end != string::npos)
		    tmp = paramLine.substr(start);

		//if a colon is found, then there is a format error
		if(tmp.find(":") != string::npos)
		    throw YellowAlert();
		else
		{
		    //fit statistic should be the last column. so break
                    m_chain->statistic(tmp);
		    start = string::npos;
		    break;
		}
	    }
	    inPar.modName = Model::DEFAULT();
	    inPar.index = index;
        }
        else if (index)
        {
           inPar.modName = modName;
           inPar.index = index;
        }
        else
           throw YellowAlert();
        start = paramLine.find_first_not_of(WS, end);
        if (start == string::npos) throw YellowAlert();
        end = paramLine.find_first_of(WS, start);
        if (end == string::npos) throw YellowAlert();
        n = end-start;
        inPar.parName = paramLine.substr(start, n);
        start = paramLine.find_first_not_of(WS, end);
        if (start == string::npos) throw YellowAlert();
        end = paramLine.find_first_of(WS, start);        
        n = (end == string::npos) ? string::npos : end-start;
        string tmpUnit = paramLine.substr(start, n);
        inPar.units = (tmpUnit == "0" ? string("") : tmpUnit);
        
        paramIDs.push_back(inPar);
        start = paramLine.find_first_not_of(WS, end);
     }
     if (paramIDs.size() != m_chain->width()-1) 
        throw YellowAlert("Mismatch between Width setting and parameter labels.\n");
     m_chain->paramIDs(paramIDs);
     m_file.close();
  }
  catch (...)
  {
     m_file.close();
     string msg("Format error in chain file ");
     msg += m_chain->getFileName();
     throw ChainIOError(msg);
  }
  
  
  //## end AsciiChain::readFileInfo%46DD90BA0181.body
}

void AsciiChain::createFile ()
{
  //## begin AsciiChain::createFile%46DD90C302F7.body preserve=yes
  m_file.open(m_chain->getFileName().c_str(), std::ios_base::out);
  if (!m_file)
  {
     string msg("Unable to create output file ");
     msg += m_chain->getFileName();
     throw ChainIOError(msg);
  }
  int savConVerbose = tpout.conVerbose();
  int savLogVerbose = tpout.logVerbose();
  XSstream::verbose(tpout,25,25);
  tcout << "Writing chain to " << m_chain->getFileName() << std::endl;
  XSstream::verbose(tpout, savConVerbose, savLogVerbose);
  m_file << std::setprecision(ChainIO::PRECISION()) << std::right;
  //## end AsciiChain::createFile%46DD90C302F7.body
}

void AsciiChain::writePoint ()
{
  //## begin AsciiChain::writePoint%46DD90CD02AE.body preserve=yes
  using namespace XSContainer;
  // Function assumes m_file is open and ready for writing.  
  // It also assumes it has already had its precision 
  // and justification set.
  // NOTE: If anything changes in here, readPointFromLine
  // may need a corresponding readjustment.
  const std::map<int,ModParam*>& varPars = fit->variableParameters();
  std::map<int,ModParam*>::const_iterator it = varPars.begin();
  std::map<int,ModParam*>::const_iterator itEnd = varPars.end();
  while (it != itEnd)
  {
     m_file << std::setw(ChainIO::FWIDTH()) << it->second->value();
     ++it;
  }
  m_file << std::setw(ChainIO::FWIDTH()) << fit->statistic() << std::endl;
  //## end AsciiChain::writePoint%46DD90CD02AE.body
}

void AsciiChain::writeFileInfo ()
{
  //## begin AsciiChain::writeFileInfo%46DD90DE00BC.body preserve=yes
  using namespace std;
  
  m_file << "!" << " Markov chain file generated by xspec \"chain\" command."
         << "\n!" << "    Do not modify, else file may not reload properly."
         << "\n!" << ChainIO::LENGTHLABEL() << ":" << flush;
  // m_length needs a fixed field width in case we want to modify it
  // later in adjustLengthInfo.
  m_lengthInfoPos = m_file.tellp();
  m_file << right << setw(s_LENGTHFIELDWIDTH) << m_chain->length() << "  " 
                << ChainIO::WIDTHLABEL() << ": " << m_chain->width() << endl;
  // output tempering info on line 4
  m_file << "!" << ChainIO::TEMPERLABEL() << ":";
  m_temperInfoPos = m_file.tellp();
  adjustTemperInfo();
  // output param IDs on line 5
  m_file << "!";
  const vector<Chain::ParamID>& parIDs = m_chain->paramIDs();
  size_t nPars = parIDs.size();
  for (size_t i=0; i<nPars; ++i)
  {
     const Chain::ParamID& parID = parIDs[i];
     if (parID.modName != Model::DEFAULT())
     {
        m_file << parID.modName << ':';
     }
     m_file << parID.index << " " << parID.parName << " ";
     string units = parID.units.length() ? parID.units : string("0");
     m_file << units << "   ";
  }

  m_file << Fit::Instance(string(""), string(""))->statMethod()->fullName() << endl;
  m_pointsStartPos = m_file.tellp();
  //## end AsciiChain::writeFileInfo%46DD90DE00BC.body
}

void AsciiChain::adjustLengthInfo ()
{
  //## begin AsciiChain::adjustLengthInfo%46DD90E4028C.body preserve=yes
   // This assumes m_lengthInfoPos has already been set to the
   // location of the length value entry in the file.  
   m_file.seekp(m_lengthInfoPos, std::ios_base::beg);
   m_file << std::right << std::setw(s_LENGTHFIELDWIDTH) 
        << m_chain->length() << std::flush;
  //## end AsciiChain::adjustLengthInfo%46DD90E4028C.body
}

void AsciiChain::moveToLine (const size_t lineNum) const
{
  //## begin AsciiChain::moveToLine%46DD90EA0157.body preserve=yes
   m_file.seekg(m_pointsStartPos);
   if (!m_file)
   {
      string errMsg("Chain file format error in ");
      errMsg += m_chain->getFileName();
      throw ChainIOError(errMsg);
   }
   // The current pos in file should now be the start of the first line
   // of parameter vals.  WARNING: The step below ASSUMES each line of 
   // values is strictly formatted by writePoint.  This is to avoid 
   // having to do a line-by-line read to get to the point of interest.
   // In each line there should be nPar+1 values including the fit statistic,
   // plus a newline character.
   std::fstream::off_type offset = lineNum*(ChainIO::FWIDTH()*m_chain->width() + 1); 
   if (offset != 0)
   {
      // We want this to land at the preceding newline char to
      // do a bare minimum check.
      m_file.seekg(offset-1, std::ios_base::cur);
      if (!m_file)
      {
         std::ostringstream errMsg;
         errMsg <<"Unable to move to line " << lineNum 
            <<" in chain file " << m_chain->getFileName();
         throw ChainIOError(errMsg.str());
      }
      char testChar(' ');
      m_file.get(testChar);
      if (testChar != '\n')
      {
         std::ostringstream errMsg;
         errMsg <<"Unable to move to line " << lineNum
            <<".\n   No newline character detected before this line.";
         throw ChainIOError(errMsg.str());
      }
   }
  //## end AsciiChain::moveToLine%46DD90EA0157.body
}

void AsciiChain::appendFile (RealArray& startingVals)
{
  //## begin AsciiChain::appendFile%46DD90F00283.body preserve=yes
  using namespace std;
  using namespace XSContainer;
  // ASSUMES calling function has already saved the original
  // parameter values, and so is capable of restoring
  // them.  
  
  // Starting point should be the last set of values in the file.
  m_file.open(m_chain->getFileName().c_str(), ios_base::in);
  if (!m_file)
  {
     string msg("Unable to open file for reading to begin append operation: ");
     msg += m_chain->getFileName();
     throw ChainIOError(msg);
  }
  startingVals.resize(m_chain->width()-1, .0);
  try
  {
     doReadPointFromLine(m_chain->length()-1, startingVals);
  }
  catch (YellowAlert&)
  {
     m_file.close();
     throw;
  }
  m_file.close();
  
  // Now reopen file for appending.
  m_file.open(m_chain->getFileName().c_str(), ios_base::app|ios_base::out);
  if(!m_file)
  {
      string msg("Unable to open chain file for appending: ");
      msg += m_chain->getFileName();
      throw ChainIOError(msg);
  }
  m_file << setprecision(ChainIO::PRECISION()) << right;
  //## end AsciiChain::appendFile%46DD90F00283.body
}

void AsciiChain::adjustTemperInfo ()
{
  //## begin AsciiChain::adjustTemperInfo%46DD90F80225.body preserve=yes
   // This assumes m_temperInfoPos has already been set to the
   // location of the start of tempering array vals in the file.
   // Also assume required field width has already been checked 
   // to be less than s_TEMPERFIELDWIDTH.
   using namespace std;
   ios_base::fmtflags saveFmt(m_file.flags());
   streamsize savePrec(m_file.precision());  
   m_file.seekp(m_temperInfoPos);
   m_file.precision(ChainIO::TEMPERPREC());
   const Chain::TemperInfoContainer& tempers = m_chain->tempering();
   for (size_t i=0; i<tempers.size(); ++i)
   {
      m_file << " " << tempers[i].first << " "
                << scientific << tempers[i].second;
   }
   m_file << flush;
   int nPadding = s_TEMPERFIELDWIDTH - 
        static_cast<int>(m_file.tellp() - m_temperInfoPos);
   if (nPadding < 0)
      throw RedAlert("Tempering info output field width error.");
   for (int i=0; i<nPadding; ++i)
      m_file.put(' ');
   m_file << "\n" << flush;
   m_file.precision(savePrec);
   m_file.flags(saveFmt);
  //## end AsciiChain::adjustTemperInfo%46DD90F80225.body
}

bool AsciiChain::checkTemperField (const Real temperature) const
{
  //## begin AsciiChain::checkTemperField%46DD9100005D.body preserve=yes
   using namespace std;
   ostringstream testStream;
   testStream.precision(ChainIO::TEMPERPREC());
   const Chain::TemperInfoContainer& tempers = m_chain->tempering();
   for (size_t i=0; i<tempers.size(); ++i)
   {
      testStream << " " << tempers[i].first << " "
              << scientific << tempers[i].second;
   }
   testStream << " " << m_chain->length() + 1 << " " << scientific 
                << temperature << flush;
   bool willFit = (testStream.str().length() <= (size_t)s_TEMPERFIELDWIDTH);
   return willFit;
  //## end AsciiChain::checkTemperField%46DD9100005D.body
}

string AsciiChain::readTemperInfo ()
{
  //## begin AsciiChain::readTemperInfo%46DD91070313.body preserve=yes
   // This assumes file is positioned at the start of the temperature
   // info line.
   // If the parametersLine return string has any length, it will 
   // indicate that this is an older chain file format which has no 
   // tempering information.  m_temperInfoPos will be left at -1
   // in this case.
   string tempLine;
   string parametersLine;
   std::fstream::pos_type orgPos = m_file.tellg();
   std::getline(m_file, tempLine);
   string indicator("!");
   indicator += ChainIO::TEMPERLABEL() + ":";
   if (tempLine.find(indicator) != 0)
   {
      parametersLine = tempLine;
      // No temp field, so can only use default temp value.
      Chain::TemperInfoContainer defaultTemp;
      defaultTemp.push_back(std::make_pair((size_t)1,(Real)1.0));
      m_chain->tempering(defaultTemp);
   }
   else
   {
      // This line should contain tempering information.
      tempLine = tempLine.substr(indicator.length());
      if (!tempLine.length())
      {
         string errMsg("File contains Tempering label with no values: ");
         errMsg += m_chain->getFileName();
         throw ChainIOError(errMsg);
      }
      Chain::TemperInfoContainer temperArray;
      std::istringstream iss(tempLine);
      while (iss)
      {
         size_t startLength = 0;
         Real temperature = 0.0;
         iss >> startLength;
         if (!iss || !startLength)
         {
            string errMsg("Tempering line format error in file: ");
            errMsg += m_chain->getFileName();
            throw ChainIOError(errMsg);
         }
         iss >> temperature;
         // iss could be at eof, which is OK
         if (temperature == 0.0)
         {
            string errMsg("Tempering line format error in file: ");
            errMsg += m_chain->getFileName();
            throw ChainIOError(errMsg);
         }
         temperArray.push_back(std::make_pair(startLength, temperature)); 
         
         // Swallow any whitespace after val.  This is necessary
         // in case this is the last temperature val, where trailing
         // whitespace would cause another loop iteration and hence
         // failure during the startLength read attempt.
         char c;
         while (iss.get(c)) 
         {
            if (!std::isspace(c))
            {
               iss.putback(c);
               break;
            }
         }       
      }
      m_chain->tempering(temperArray);
      m_temperInfoPos = orgPos + 
                static_cast<std::streamoff>(indicator.length());
   }
   
   return parametersLine;
  //## end AsciiChain::readTemperInfo%46DD91070313.body
}

void AsciiChain::setParent (Chain* chain)
{
  //## begin AsciiChain::setParent%46DDB5070061.body preserve=yes
   m_chain = chain;
  //## end AsciiChain::setParent%46DDB5070061.body
}

void AsciiChain::testFile (const string& fileName) const
{
  //## begin AsciiChain::testFile%46DDC79103D1.body preserve=yes
  // Very basic test on a pre-existing chain, just intended to 
  // distinguish between an Ascii chain file and a FITS chain file.
  // If it can open the file but does not recognize it as Ascii, 
  // it should throw without printing any error message.
  using namespace std;
  m_file.open(fileName.c_str(), ios_base::in);
  if (!m_file)
  {
     string msg("Unable to open chain file ");
     msg += fileName;
     throw ChainIOError(msg);
  }
  
  const size_t NCHARS = 9;
  char testChars[NCHARS];
  // The read function does NOT place a trailing 0 in the array.
  testChars[NCHARS-1] = 0;
  m_file.read(testChars,NCHARS-1);
  if (!m_file)
  {
     m_file.close();
     throw YellowAlert();
  }
  const string testStr(testChars);
  if (testStr != string("! Markov"))
  {
     m_file.close();
     throw YellowAlert();
  }
  m_file.close();
  //## end AsciiChain::testFile%46DDC79103D1.body
}

bool AsciiChain::allowsTemper () const
{
  //## begin AsciiChain::allowsTemper%46DF28BB03D3.body preserve=yes
   return (int)m_temperInfoPos != -1;
  //## end AsciiChain::allowsTemper%46DF28BB03D3.body
}

// Additional Declarations
  //## begin AsciiChain%46DD7BF103B0.declarations preserve=yes
  //## end AsciiChain%46DD7BF103B0.declarations

//## begin module%46D85065025F.epilog preserve=yes
//## end module%46D85065025F.epilog
